import java.awt.*;
import java.awt.event.*;
import java.util.*;

class ExampleView3 extends SCView {

	/**
	 *  The business model associated to this view.
	 */
	private BusinessModel businessModel_;
	private BusinessModel businessModel() { return businessModel_; }
	private void businessModel( BusinessModel aBusinessModel ) { businessModel_ = aBusinessModel; }


    private ExampleView3(){
        super("Example View 3");
        this.initialize();
    }

    public static void main(String argv[]){
        ExampleView3 theExampleView3 = new ExampleView3();
        theExampleView3.show();
    }

    private void initialize(){

        this.businessModel( new BusinessModel() );
        this.businessModel().addObserver( this );

        this.setLayout(null);

        this.initMenu();


        this.initWidgets();

        this.setSize(475,390);
        this.setLocation(80,80);

    }

    public void test1(){
        System.out.println("test1 in ExampleView3");
    }

    public void test2(){
        System.out.println("test2 in ExampleView3");
    }
    public void nickelButtonPressed(){
        System.out.println("nickelButtonPressed in ExampleView3");
        ((ActionLabel) this.getWidget("action Label")).stopTheThread();

        this.businessModel().addFive();
    }
    public void shadowButtonPressed(){
        System.out.println("shadowButtonPressed in ExampleView3");
        ((ActionLabel) this.getWidget("action Label")).startTheThread();

        this.businessModel().addOne();
    }

    private void initWidgets(){
        this.addWidget("nickel Button", new NickelButton(this));
        this.addWidget("shadow Button", new ShadowButton(this));
        this.addWidget("action Label", new ActionLabel());
        this.addWidget("response Label", new ResponseLabel());
        this.addWidget("instructions TextArea", new InstructionsTextArea());

    }

    public void update(Observable obs, Object o){
        ((Label) this.getWidget("response Label")).setText((String) o);
    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();


            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);


            aMenu = new Menu("Test");
                aMenuItem = new MenuItem("Test1");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Test1");
            aMenu.add(aMenuItem);
                aMenuItem = new MenuItem("Test2");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Test2");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);


        this.setMenuBar(aMenuBar);
    }
   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
        if( actionCommand.equals("Test1") ){
            this.test1();
            return;
        }
        if( actionCommand.equals("Test2") ){
            this.test2();
            return;
        }
    }


    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing ExampleView3");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }

}

